//NettoyerTextes_510f.js
// 11.11.2017 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Nettoyer des textes

/*Credits:
 Converti des conseils prcieux de la part de Marco Morgenthaler et insr ses Greps. 
 Faire ressortir en couleur des modifications ainsi que la conversion des points de 
  suspension en ellipses a t demand par Quartz.
 Remplacer des apostrophes dans des chiffres est un souhait de la part de Michel.
 Jrgen Althaus ainsi que Christoph ("cwenet") signalaient que l'espace derrire un 
	chiffre d'une note de bas de page est supprim quand on a choisi l'option "espaces 
	au dbut des lignes = les supprimer"
*/

// le choix du quadratin partiel pour la microtypographie
mikVal = "\u200A"; // = une espace ultrafine
//mikVal = "\u2009"; // = une espace fine

// le nombre minimal des caractres entre les guillemets simples
nChar = 2;

// lorsque le nombre minimal est un: convertir les guillemets simples en apostrophes aux termes suivants
corrApo = new Array("Rock 'n' Roll", "Rhythm 'n' Blues", "Fish 'n' Chips");

// le remplacement des apostrophes  l'intrieur des chiffres
sepVal = ""; // remplacer par rien
//sepVal = "\u200A"; // = une espace ultrafine
//sepVal = "\u2009"; // = une espace fine

// activer l'affichage des dialogues
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// tester si un document est ouvert
if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// le document au premier plan
curDoc = app.documents[0];

	// appeler la fonction qui lit les prfrences mmorises
var defStr = getPrefs();
	// extraire les valeurs (si le fichier des prfrences existe)
if (defStr != "") {
	var repDef = defStr.split("\n");
	ck01 = repDef[0];
	if (ck01 == "true") {ck01 = true;} else {ck01 = false;}
	ck02 = repDef[1];
	if (ck02 == "true") {ck02 = true;} else {ck02 = false;}
	ck03 = repDef[2];
	if (ck03 == "true") {ck03 = true;} else {ck03 = false;}
	ck04 = repDef[3];
	if (ck04 == "true") {ck04 = true;} else {ck04 = false;}
	ck05 = repDef[4];
	if (ck05 == "true") {ck05 = true;} else {ck05 = false;}
	ck06 = repDef[5];
	if (ck06 == "true") {ck06 = true;} else {ck06 = false;}
	ck07 = repDef[6];
	if (ck07 == "true") {ck07 = true;} else {ck07 = false;}
	ck08 = repDef[7];
	if (ck08 == "true") {ck08 = true;} else {ck08 = false;}
	ck09 = repDef[8];
	if (ck09 == "true") {ck09 = true;} else {ck09 = false;}
	ck10 = repDef[9];
	if (ck10 == "true") {ck10 = true;} else {ck10 = false;}
	ck11 = repDef[10];
	if (ck11 == "true") {ck11 = true;} else {ck11 = false;}
	ck12 = repDef[11];
	if (ck12 == "true") {ck12 = true;} else {ck12 = false;}
	ck13 = repDef[12];
	if (ck13 == "true") {ck13 = true;} else {ck13 = false;}
	ck14 = repDef[13];
	if (ck14 == "true") {ck14 = true;} else {ck14 = false;}
	ck15 = repDef[14];
	if (ck15 == "true") {ck15 = true;} else {ck15 = false;}
	rDef = repDef[15];
	if (rDef == "0") {
		rb01 = 1;
		rb02 = 0;
	}
	else if (rDef == "1") {
		rb01 = 0;
		rb02 = 1;
	}
}
else { // quand le fichier des prfrences est introuvable
	ck01 = true;
	ck02 = true;
	ck03 = true;
	ck04 = true;
	ck05 = true;
	ck06 = true;
	ck07 = true;
	ck08 = true;
	ck09 = false;
	ck10 = false;
	ck11 = false;
	ck12 = false;
	ck13 = false;
	ck14 = false;
	ck15 = false;
	rb01 = 0;
	rb02 = 1;
}

// appeler la fonction qui prpare le dialogue
askUser();

// effacer les prfrences rechercher/remplacer
app.findTextPreferences = app.changeTextPreferences = null;
app.findGrepPreferences = app.changeGrepPreferences = null;

// prparer les options rechercher/remplacer
app.findChangeTextOptions.wholeWord = false;
app.findChangeTextOptions.caseSensitive = true;

// mmoriser la prfrence "Utiliser les apostrophes typographiques"
if (apoMod == true || quoMod == true) {
	var typoQuotes = curDoc.textPreferences.typographersQuotes;
	if (typoQuotes == false) {
		app.documents[0].textPreferences.typographersQuotes = true;
	}
}

// la nuance temporaire pour marquer les modifications
if (tmpCol == true) {
	tmpColor = curDoc.swatches.itemByName("Rouge_tmp");
	if (!tmpColor.isValid) {
		tmpColor = curDoc.colors.add();
		tmpColor.properties = {space:ColorSpace.CMYK, colorValue:[0,100,100,0], name:"Rouge_tmp"};
	}
}

// vrifier la slction ...
var curSel = app.selection;
// ... la compter ...
var nItems = curSel.length;
// ... et l'annuler
app.selection = null;

// mmoriser l'option "Contrler le document en amont" ...
var prefOff = curDoc.preflightOptions.preflightOff;

// le dsactiver si ncessaire
if (prefOff == false) {
	curDoc.preflightOptions.preflightOff = true;
}

// ... arrter le raffrachissment ...
app.scriptPreferences.enableRedraw = false;

// quand il n'y a pas de slection
if (nItems == 0) {
	var curObj = curDoc;
	makeChange(curObj, "okay");
}
else {
	var idArr = new Array();
	// sinon, une boucle  travers la slection
	for (var n=0; n<nItems; n++) {
		var curObj = curSel[n];
		var curType = curObj.constructor.name;
		if (curType == "TextFrame") {
			curObj = curObj.parentStory;
			var curID = curObj.id;
			var isInList = checkID(idArr, curID);
			if (!isInList) {
				idArr.push(curID);
				if (nItems == 1) {
					var selType = "okay";
				}
				else {
					var selType = "nope";
				}
				makeChange(curObj, selType);
			}
		}
		else if (curObj.hasOwnProperty("baseline")) {
			if (curType != "InsertionPoint") {
				var selType = "okay";
				makeChange(curObj, selType);
			}
			else if (curType == "InsertionPoint") {
				curObj = curObj.parentTextFrames[0].parentStory;
				var selType = "okay";
				makeChange(curObj, selType);
			}
		}
	}
	if (selType == "nope") {
		if (tmpCol == true) {
			var idArr = new Array();
			// une boucle  travers la slection
			for (var n=0; n<nItems; n++) {
				var curObj = curSel[n];
				var curType = curObj.constructor.name;
				if (curType == "TextFrame") {
					curObj = curObj.parentStory;
					var curID = curObj.id;
					var isInList = checkID(idArr, curID);
					if (!isInList) {
						idArr.push(curID);
						colorApo(curObj);
					}
				}
			}
		}
	}
}

// annuler une slection ventuelle
app.selection = null;

// activer le Preflight (si ncessaire)
if (prefOff == false) {
	curDoc.preflightOptions.preflightOff = false;
}

// rtablir le raffrachissement
app.scriptPreferences.enableRedraw = true;

// die Suchen/Ersetzen-Preferences zurcksetzen
app.findTextPreferences = app.changeTextPreferences = null;
app.findGrepPreferences = app.changeGrepPreferences = null;

// rstaurer la prfrence "Utiliser les apostrophes typographiques" (si ncessaire)
if (apoMod == true || quoMod == true) {
	if (typoQuotes == false) {
		curDoc.textPreferences.typographersQuotes = false;
	}
}

// annoncer la fin de l'action
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Termin.");
dlog.show();
// une petite pause
$.sleep(999);
// fermer la fentre
dlog.close();


///////////////////////////////////////////////////////////////////////////////////////////////////
// les fonctions //////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
// prparer les informations //////////////////////////////////////////////////////////////////////
function getPrefs() {
	var defStr = "";
	// lire le fichier contenant les valeurs enregistres
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/rep508.txt");
	}
	else {
		var f = new File("~/Library/Preferences/rep508.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// prparer le dialogue, l'afficher et mmoriser le rsultat //////////////////////////////////////
function askUser() {
	// effacer des dialogues rests ouverts
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// prparer le dialogue
	var aDialog = app.dialogs.add({name:"NettoyerTextes"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Slectionner les options", minWidth:75});
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				if (rb02 == 1) {
					var spcRedDec = checkboxControls.add({staticLabel:" espaces multiples = les rduire  une seule", checkedState:ck01});
					var pspDelDec = checkboxControls.add({staticLabel:" espaces au dbut des lignes = les supprimer", checkedState:ck02});
					var spcDelDec = checkboxControls.add({staticLabel:" espaces aux ponctuations ( ? ! ; : ) = les supprimer", checkedState:ck03});
					var mikTypDec = checkboxControls.add({staticLabel:" devant les ponctuations = insrer un cadratin partiel", checkedState:ck04});
					var hypModDec = checkboxControls.add({staticLabel:" traits d'union = les convertir en demi-tirets", checkedState:ck05});
					var eliCnvDec = checkboxControls.add({staticLabel:" points de suspension = les convertir en ellipses", checkedState:ck06});
					var apoModDec = checkboxControls.add({staticLabel:" apostrophes et guillemets simples = les convertir", checkedState:ck07});
					var quoModDec = checkboxControls.add({staticLabel:" \"guillemets\" doubles = les rectifier", checkedState:ck08});
					var quoMikDec = checkboxControls.add({staticLabel:" aux guillemets = insrer un cadratin partiel", checkedState:ck09});
					var empDelDec = checkboxControls.add({staticLabel:" lignes de blanc = les supprimer", checkedState:ck10});
					var shtDelDec = checkboxControls.add({staticLabel:" caractres nouvelle ligne = les supprimer", checkedState:ck11});
					var apoDelDec = checkboxControls.add({staticLabel:" apostrophes dans les chiffres = les supprimer", checkedState:ck12});
					var hypDelDec = checkboxControls.add({staticLabel:" csures manuelles = les supprimer", checkedState:ck13});
					var shpCnvDec = checkboxControls.add({staticLabel:" \"\" = les convertir en \"ss\"", checkedState:ck14});
					var tmpColDec = checkboxControls.add({staticLabel:" faire ressortir les modifications visibles en rouge", checkedState:ck15});
				}
				else {
					spcRedDec=pspDelDec=spcDelDec=mikTypDec=hypModDec=eliCnvDec=apoModDec=quoModDec=quoMikDec=empDelDec=shtDelDec=apoDelDec=hypDelDec=shpCnvDec=tmpColDec=false;
					var checkArr = new Array(ck01,ck02,ck03,ck04,ck05,ck06,ck07,ck08,ck09,ck10,ck11,ck12,ck13,ck14,ck15);
					var okay = false;
					for (var c=0; c<checkArr.length; c++) {
						if (checkArr[c] == true) {
							okay = true;
							break;
						}
					}
					if (okay) {
						if (ck01 == true) {
							var spcRedDec = checkboxControls.add({staticLabel:" espaces multiples = les rduire  une seule", checkedState:ck01});
						}
						if (ck02 == true) {
							var pspDelDec = checkboxControls.add({staticLabel:" espaces au dbut des lignes = les supprimer", checkedState:ck02});
						}
						if (ck03 == true) {
							var spcDelDec = checkboxControls.add({staticLabel:" espaces aux ponctuations ( ? ! ; : ) = les supprimer", checkedState:ck03});
						}
						if (ck04 == true) {
							var mikTypDec = checkboxControls.add({staticLabel:" devant les ponctuations = insrer un cadratin partiel", checkedState:ck04});
						}
						if (ck05 == true) {
							var hypModDec = checkboxControls.add({staticLabel:" traits d'union = les convertir en demi-tirets", checkedState:ck05});
						}
						if (ck06 == true) {
							var eliCnvDec = checkboxControls.add({staticLabel:" points de suspension = les convertir en ellipses", checkedState:ck05});
						}
						if (ck07 == true) {
							var apoModDec = checkboxControls.add({staticLabel:" apostrophes et guillemets simples = les convertir", checkedState:ck07});
						}
						if (ck08 == true) {
							var quoModDec = checkboxControls.add({staticLabel:" \"guillemets\" doubles = les rectifier", checkedState:ck08});
						}
						if (ck09 == true) {
							var quoMikDec = checkboxControls.add({staticLabel:" aux guillemets = insrer un cadratin partiel", checkedState:ck09});
						}
						if (ck10 == true) {
							var empDelDec = checkboxControls.add({staticLabel:" lignes de blanc = les supprimer", checkedState:ck10});
						}
						if (ck11 == true) {
							var shtDelDec = checkboxControls.add({staticLabel:" caractres nouvelle ligne = les supprimer", checkedState:ck11});
						}
						if (ck12 == true) {
							var apoDelDec = checkboxControls.add({staticLabel:" apostrophes dans les chiffres = les supprimer", checkedState:ck12});
						}
						if (ck13 == true) {
							var hypDelDec = checkboxControls.add({staticLabel:" csures manuelles = les supprimer", checkedState:ck13});
						}
						if (ck14 == true) {
							var shpCnvDec = checkboxControls.add({staticLabel:" \"\" = les convertir en \"ss\"", checkedState:ck14});
						}
						if (ck15 == true) {
							var tmpColDec = checkboxControls.add({staticLabel:" faire ressortir les modifications visibles en rouge", checkedState:ck15});
						}
					}
					else {
						var msgArr = new Array(
"Quel farceur ... :-)                          ", 
"Tout est loin?!? Et maintenant? ;-)           ", 
"CՎtait pour tester le programmeur? Ou bien?  ", 
"Il est positif dՐtre curieux!                ", 
"Recherch et dj trouv :-)                ", 
"Ah... le finaud!                              ", 
"On joue le rabat-joie?                        ", 
"Pas de soucis, cela va s'arranger.            ", 
"Et alors? Surpris?                            ", 
"Tent de provoquer un plantage? ;-)           "); 
						var rndNum = Math.floor(Math.random()*10);
						if (rndNum > 10) {
							rndNum = 10;
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:52});
							staticTexts.add({staticLabel:msgArr[rndNum]});
						}
					}
				}
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:" ", minWidth:60});
			with(shwButtns = radiobuttonGroups.add()) {
				radiobuttonControls.add({staticLabel:" cacher les options non utilises", checkedState:rb01});
				radiobuttonControls.add({staticLabel:" afficher toutes les options",   checkedState:rb02});
			}
		}
	}
	// afficher le dialogue et mmoriser le rsultat
	var dResult = aDialog.show();
	if (dResult == true) {
		spcRed = spcRedDec.checkedState;
		pspDel = pspDelDec.checkedState;
		spcDel = spcDelDec.checkedState;
		mikMod = mikTypDec.checkedState;
		hypMod = hypModDec.checkedState;
		eliCnv = eliCnvDec.checkedState;
		apoMod = apoModDec.checkedState;
		quoMod = quoModDec.checkedState;
		quoMik = quoMikDec.checkedState;
		empDel = empDelDec.checkedState;
		shtDel = shtDelDec.checkedState;
		apoDel = apoDelDec.checkedState;
		hypDel = hypDelDec.checkedState;
		shpCnv = shpCnvDec.checkedState;
		tmpCol = tmpColDec.checkedState;
		shwDec = shwButtns.selectedButton;
		
		aDialog.destroy();
		
		// la liste des rglages...
		var prefsList = new Array(spcRed,pspDel,spcDel,mikMod,hypMod,eliCnv,apoMod,quoMod,quoMik,empDel,shtDel,apoDel,hypDel,shpCnv,tmpCol,shwDec);
		// ... la convertir en chane de texte...
		var curDef = prefsList.join("\n");
		// ... et l'envoyer  la fonction qui l'crit dans un fichier
		writeResult(curDef);
	}
	else {
		aDialog.destroy();
		exit();
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// crire le rsultat dans un fichier /////////////////////////////////////////////////////////////
function writeResult(curDef) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/rep508.txt");
	}
	else {
		var f = File("~/Library/Preferences/rep508.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// vrifier les IDs des chanes de texte //////////////////////////////////////////////////////////
function checkID(idArr, curID) {
	var isListed = false;
	for (var n=0; n<idArr.length; n++) {
		if (idArr[n] == curID) {
			isListed = true;
			break;
		}
	}
	return isListed;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// la fonction rechercher/remplacer ///////////////////////////////////////////////////////////////
function makeChange(curObj, selType) {
	if (apoDel) {
		// supprimer des apostrophes dans des valeurs (ou les remplacer)
		app.findGrepPreferences.findWhat   = "([0-9])['\u0020\u200A\u2009]([0-9])";
		app.changeGrepPreferences.changeTo = "$1" + sepVal + "$2";
		curObj.changeGrep();
	}
	
	if (hypDel) {
		// supprimer des csures insres manuellement
		app.findGrepPreferences.findWhat   = "-( )?\r(\\l)";
		app.changeGrepPreferences.changeTo = "$2";
		curObj.changeGrep();
		app.findGrepPreferences.findWhat   = "-( )?\n(\\l)";
		app.changeGrepPreferences.changeTo = "$2";
		curObj.changeGrep();
		if (!shtDel) {
			app.findGrepPreferences.findWhat   = "-( )?\n";
			app.changeGrepPreferences.changeTo = "-";
			curObj.changeGrep();
		}
	}
	
	if (shtDel) {
		// supprimer les caractres nouvelle ligne
		if (!(hypDel)) {
			app.findGrepPreferences.findWhat   = "-( )?\n(\\l)";
			app.changeGrepPreferences.changeTo = "$2";
			curObj.changeGrep();
		}
		app.findGrepPreferences.findWhat   = "-( )?\n";
		app.changeGrepPreferences.changeTo = "-";
		curObj.changeGrep();
		app.findTextPreferences.findWhat   = "\n";
		app.changeTextPreferences.changeTo = " ";
		curObj.changeText();
		if (!spcRed) { // quand il ne faut pas rduire les espaces multiples  une seule
			// rduire deux espaces  une seule
			app.findTextPreferences.findWhat   = "  ";
			app.changeTextPreferences.changeTo = " ";
			curObj.changeText();
		}
	}
		
	if (spcRed) {
		// rduire les espaces multiples  une seule
		app.findGrepPreferences.findWhat   = "\\p{Z*}(?=\\p{Z*})";
		app.changeGrepPreferences.changeTo = "";
		curObj.changeGrep();
	}
	
	if (spcDel) {
		// supprimer es spaces aux ponctuations
		app.findGrepPreferences.findWhat   = " ([?!;:])";
		app.changeGrepPreferences.changeTo = "$1";
		curObj.changeGrep();
		app.findGrepPreferences = app.changeGrepPreferences = null;
	}
	
	if (hypMod) {
		// convertir les traits d'union en demi-tirets
		if (tmpCol == true) {
			app.changeTextPreferences.fillColor = tmpColor;
		}
		app.findTextPreferences.findWhat   = " - ";
		app.changeTextPreferences.changeTo = "  ";
		curObj.changeText();
		app.findTextPreferences.findWhat   = " -, ";
		app.changeTextPreferences.changeTo = " , ";
		curObj.changeText();
		app.findTextPreferences = app.changeTextPreferences = null;
	}
	
	if (apoMod) {
		// convertir les apostrophes droits en apostrophes typographiques...
		app.findGrepPreferences.findWhat   = "[']";
		app.changeGrepPreferences.changeTo = "\u2019";
		curObj.changeGrep();
		// ... et corriger les guillemets simples  l'aide des Greps "by Marco"
		app.findGrepPreferences.findWhat   = "\\A\u2019([^\u2019]{" + nChar + ",})\u2019(?!\\w)";
		app.changeGrepPreferences.changeTo = "~[$1~]";
		curObj.changeGrep();
		app.findGrepPreferences.findWhat   = "(?<=[\\s[(\"])\u2019([^\u2019]{" + nChar + ",})\u2019(?!\\w)";
		app.changeGrepPreferences.changeTo = "~[$1~]";
		curObj.changeGrep();
	}
	
	if (eliCnv) {
		// supprimer des espaces  l'intrieur de parenthses...
		app.findGrepPreferences.findWhat   = "(?<=[\[\(])\\s?(\\.{3,4})\\s?(?=[\]\)])";
		app.changeGrepPreferences.changeTo = "$1";
		curObj.changeGrep();
		if (tmpCol == true) {
			app.changeGrepPreferences.fillColor = tmpColor;
		}
		// ... et convertir des points de suspension en ellipses
		app.findGrepPreferences.findWhat   = "(\\s?)(\\.{3,4})(\\s?)";
		app.changeGrepPreferences.changeTo = "$1$3";
		curObj.changeGrep();
		app.findGrepPreferences = app.changeGrepPreferences = null;
	}
	
	if (quoMod) { // des Greps additionnels de la part de Marco
		// Grep 1 (au dbut de la chane / 2. supprimer l'espace [devant des guillemets doubles]): 
		app.findGrepPreferences.findWhat   = "(?s)(?<=\\A[\"])\\s+(?=(.+?)\\s*[\"](?![\\w]))";
		app.changeGrepPreferences.changeTo = "";
		curObj.changeGrep();
		// Grep 2 (au dbut de la chane / 1. supprimer l'espace [aprs des guillemets doubles]): 
		app.findGrepPreferences.findWhat   = "(?s)\\A[\"](.+?)\\s*[\"](?![\\w])";
		app.changeGrepPreferences.changeTo = "~{$1~}";
		curObj.changeGrep();
		// Grep 3 (dans la chane / 2. supprimer l'espace [devant des guillemets doubles]): 
		app.findGrepPreferences.findWhat   = "(?s)(?<=[\\s([])[\"](\\s*.+?)\\s*[\"](?![\\w])";
		app.changeGrepPreferences.changeTo = "~{$1~}";
		curObj.changeGrep();
		// Grep 4 (dans la chane / 1. supprimer l'espace [aprs des guillemets doubles]): 
		app.findGrepPreferences.findWhat   = "(?s)(?<=[\\s([][\"])\\s+(?=.+?[\"])";
		app.changeGrepPreferences.changeTo = "";
		curObj.changeGrep();

		// Grep 1a (au dbut de la chane / 2. supprimer l'espace [devant des guillemets simples]): 
		app.findGrepPreferences.findWhat   = "(?s)(?<=\\A[])\\s+(?=(.+?)\\s*[](?![\\w]))";
		app.changeGrepPreferences.changeTo = "";
		curObj.changeGrep();
		// Grep 2a (au dbut de la chane / 1. supprimer l'espace [aprs des guillemets simples]): 
		app.findGrepPreferences.findWhat   = "(?s)\\A[](.+?)\\s*[](?![\\w])";
		app.changeGrepPreferences.changeTo = "$1";
		curObj.changeGrep();
		// Grep 3a (dans la chane / 2. supprimer l'espace [devant des guillemets simples]): 
		app.findGrepPreferences.findWhat   = "(?s)(?<=[\\s([])[](\\s*.+?)\\s*[](?![\\w])";
		app.changeGrepPreferences.changeTo = "$1";
		curObj.changeGrep();
		// Grep 4a (dans la chane / 1. supprimer l'espace [aprs des guillemets simples]): 
		app.findGrepPreferences.findWhat   = "(?s)(?<=[\\s([][])\\s+(?=.+?[])";
		app.changeGrepPreferences.changeTo = "";
		curObj.changeGrep();
	}
	
	if (quoMik) { // encore des Greps de la part de Marco
		// Grep 5 (1. insrer un cadratin partiel aprs des guillemets doubles): 
		app.findGrepPreferences.findWhat   = "(?=\\S[^]*?)";
		app.changeGrepPreferences.changeTo = "$0" + mikVal;
		curObj.changeGrep();
		// Grep 6 (2. insrer un cadratin partiel devant des guillemets doubles): 
		app.findGrepPreferences.findWhat   = "(?<=" + mikVal + ")[^]*?(?=)";
		app.changeGrepPreferences.changeTo = "$0" + mikVal;
		curObj.changeGrep();
		
		// Grep 5a (1. insrer un cadratin partiel aprs des guillemets simples): 
		app.findGrepPreferences.findWhat   = "(?=\\S[^]*?)";
		app.changeGrepPreferences.changeTo = "$0" + mikVal;
		curObj.changeGrep();
		// Grep 6a (2. insrer un cadratin partiel devant des guillemets simples): 
		app.findGrepPreferences.findWhat   = "(?<=" + mikVal + ")[^]*?(?=)";
		app.changeGrepPreferences.changeTo = "$0" + mikVal;
		curObj.changeGrep();
	}
	
	if (mikMod) {
		// de la microtypographie (insrer le cadratin partiel dsir aux ponctuations)
		app.findGrepPreferences.findWhat   = "(\\s)?([?!;:])";
		app.changeGrepPreferences.changeTo = mikVal + "$2";
		curObj.changeGrep();
	}
	
	if (empDel) {
		// supprimer des lignes de blanc
		app.findGrepPreferences.findWhat   = "\n\n+";
		app.changeGrepPreferences.changeTo = "\r";
		curObj.changeGrep();
		app.findGrepPreferences.findWhat   = "\n\r";
		curObj.changeGrep();
		app.findGrepPreferences.findWhat   = "\r\n";
		curObj.changeGrep();
		app.findGrepPreferences.findWhat   = "\r\r+";
		curObj.changeGrep();
	}
	
	if (shpCnv) {
		// convertir "" en "ss"
		if (tmpCol == true) {
			app.changeTextPreferences.fillColor = tmpColor;
		}
		app.findTextPreferences.findWhat   = "";
		app.changeTextPreferences.changeTo = "ss";
		curObj.changeText();
		app.findTextPreferences = app.changeTextPreferences = null;
	}
	
	if (apoMod) {
		// rtablir Rock 'n' Roll, etc.
		if (nChar == 1) { // quand des caractres isols sont entours par des guillemets
			try {
				var nApo = corrApo.length; // le nombre des lments
				for (var n=0; n<nApo; n++) {
					var exprParts = corrApo[n].split(" 'n' ");
					app.findGrepPreferences.findWhat   = exprParts[0] + "(\\s)[](\\s)?n(\\s)?[](\\s)" + exprParts[1];
					app.changeGrepPreferences.changeTo = exprParts[0] + "$1\u2019n\u2019$4" + exprParts[1];
					curObj.changeGrep();
				}
			}
			catch (e) {
			}
		}
	}
	
	// supprimer le dbut temporaire de la chane de texte
	if (apoMod == true || quoMod == true) {
		app.findGrepPreferences.findWhat   = "\\A~|";
		app.changeGrepPreferences.changeTo = "";
		curObj.changeGrep();
	}
	
	// supprimer des espaces au dbut des lignes
	if (pspDel) {
		// remplacer l'espace aprs le chiffre d'une note de bas de page
		app.findGrepPreferences.findWhat   = "(?<=~F) ";
		app.changeGrepPreferences.changeTo = "";
		curObj.changeGrep();
		//  prsent: supprimer des espaces au dbut des lignes
		app.findGrepPreferences.findWhat   = "(?<!.)\u0020";
		app.changeGrepPreferences.changeTo = "";
		curObj.changeGrep();
		// rtablir l'espace  la note de bas de page
		app.findTextPreferences.findWhat   = "";
		app.changeTextPreferences.changeTo = " ";
		curObj.changeText();
	}
	
	if (selType == "okay") {
		// colorier les apostrophes et les guillemets simples
		if (apoMod) {
			if (tmpCol == true) {
				app.changeGrepPreferences.fillColor = tmpColor;
				app.findGrepPreferences.findWhat   = "'";
				app.changeGrepPreferences.changeTo = "$0";
				curObj.changeGrep();
			}
		}
		
		// colorier les guillemets doubles
		if (quoMod) {
			if (tmpCol == true) {
				app.changeGrepPreferences.fillColor = tmpColor;
				app.findGrepPreferences.findWhat   = "\"";
				app.changeGrepPreferences.changeTo = "$0";
				curObj.changeGrep();
			}
		}
	}
}

function colorApo(curObj) {
	// colorier les apostrophes et les guillemets simples
	if (apoMod) {
		app.changeGrepPreferences.fillColor = tmpColor;
		app.findGrepPreferences.findWhat   = "'";
		app.changeGrepPreferences.changeTo = "$0";
		curObj.changeGrep();
	}
	
	// colorier les guillemets doubles
	if (quoMod) {
		app.changeGrepPreferences.fillColor = tmpColor;
		app.findGrepPreferences.findWhat   = "\"";
		app.changeGrepPreferences.changeTo = "$0";
		curObj.changeGrep();
	}
}